import { Construct } from 'constructs';
import { TerraformResource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
/**
 *
 */
export interface RepositoryConfig extends TerraformMetaArguments {
    /**
     *
     */
    readonly allowMergeCommit?: boolean;
    /**
     *
     */
    readonly allowRebaseMerge?: boolean;
    /**
     *
     */
    readonly allowSquashMerge?: boolean;
    /**
     *
     */
    readonly archived?: boolean;
    /**
     *
     */
    readonly autoInit?: boolean;
    /**
     * Can only be set after initial repository creation, and only if the target branch exists.
     */
    readonly defaultBranch?: string;
    /**
     *
     */
    readonly deleteBranchOnMerge?: boolean;
    /**
     *
     */
    readonly description?: string;
    /**
     *
     */
    readonly gitignoreTemplate?: string;
    /**
     *
     */
    readonly hasDownloads?: boolean;
    /**
     *
     */
    readonly hasIssues?: boolean;
    /**
     *
     */
    readonly hasProjects?: boolean;
    /**
     *
     */
    readonly hasWiki?: boolean;
    /**
     *
     */
    readonly homepageUrl?: string;
    /**
     *
     */
    readonly isTemplate?: boolean;
    /**
     *
     */
    readonly licenseTemplate?: string;
    /**
     *
     */
    readonly name: string;
    /**
     *
     */
    readonly private?: boolean;
    /**
     *
     */
    readonly topics?: string[];
    /**
     * template block.
     */
    readonly template?: RepositoryTemplate[];
}
/**
 *
 */
export interface RepositoryTemplate {
    /**
     *
     */
    readonly owner: string;
    /**
     *
     */
    readonly repository: string;
}
/**
 *
 */
export declare class Repository extends TerraformResource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: RepositoryConfig);
    private _allowMergeCommit?;
    /**
     *
     */
    get allowMergeCommit(): boolean;
    /**
     *
     */
    set allowMergeCommit(value: boolean);
    /**
     *
     */
    resetAllowMergeCommit(): void;
    /**
     *
     */
    get allowMergeCommitInput(): boolean | undefined;
    private _allowRebaseMerge?;
    /**
     *
     */
    get allowRebaseMerge(): boolean;
    /**
     *
     */
    set allowRebaseMerge(value: boolean);
    /**
     *
     */
    resetAllowRebaseMerge(): void;
    /**
     *
     */
    get allowRebaseMergeInput(): boolean | undefined;
    private _allowSquashMerge?;
    /**
     *
     */
    get allowSquashMerge(): boolean;
    /**
     *
     */
    set allowSquashMerge(value: boolean);
    /**
     *
     */
    resetAllowSquashMerge(): void;
    /**
     *
     */
    get allowSquashMergeInput(): boolean | undefined;
    private _archived?;
    /**
     *
     */
    get archived(): boolean;
    /**
     *
     */
    set archived(value: boolean);
    /**
     *
     */
    resetArchived(): void;
    /**
     *
     */
    get archivedInput(): boolean | undefined;
    private _autoInit?;
    /**
     *
     */
    get autoInit(): boolean;
    /**
     *
     */
    set autoInit(value: boolean);
    /**
     *
     */
    resetAutoInit(): void;
    /**
     *
     */
    get autoInitInput(): boolean | undefined;
    private _defaultBranch?;
    /**
     *
     */
    get defaultBranch(): string;
    /**
     *
     */
    set defaultBranch(value: string);
    /**
     *
     */
    resetDefaultBranch(): void;
    /**
     *
     */
    get defaultBranchInput(): string | undefined;
    private _deleteBranchOnMerge?;
    /**
     *
     */
    get deleteBranchOnMerge(): boolean;
    /**
     *
     */
    set deleteBranchOnMerge(value: boolean);
    /**
     *
     */
    resetDeleteBranchOnMerge(): void;
    /**
     *
     */
    get deleteBranchOnMergeInput(): boolean | undefined;
    private _description?;
    /**
     *
     */
    get description(): string;
    /**
     *
     */
    set description(value: string);
    /**
     *
     */
    resetDescription(): void;
    /**
     *
     */
    get descriptionInput(): string | undefined;
    /**
     *
     */
    get etag(): string;
    /**
     *
     */
    get fullName(): string;
    /**
     *
     */
    get gitCloneUrl(): string;
    private _gitignoreTemplate?;
    /**
     *
     */
    get gitignoreTemplate(): string;
    /**
     *
     */
    set gitignoreTemplate(value: string);
    /**
     *
     */
    resetGitignoreTemplate(): void;
    /**
     *
     */
    get gitignoreTemplateInput(): string | undefined;
    private _hasDownloads?;
    /**
     *
     */
    get hasDownloads(): boolean;
    /**
     *
     */
    set hasDownloads(value: boolean);
    /**
     *
     */
    resetHasDownloads(): void;
    /**
     *
     */
    get hasDownloadsInput(): boolean | undefined;
    private _hasIssues?;
    /**
     *
     */
    get hasIssues(): boolean;
    /**
     *
     */
    set hasIssues(value: boolean);
    /**
     *
     */
    resetHasIssues(): void;
    /**
     *
     */
    get hasIssuesInput(): boolean | undefined;
    private _hasProjects?;
    /**
     *
     */
    get hasProjects(): boolean;
    /**
     *
     */
    set hasProjects(value: boolean);
    /**
     *
     */
    resetHasProjects(): void;
    /**
     *
     */
    get hasProjectsInput(): boolean | undefined;
    private _hasWiki?;
    /**
     *
     */
    get hasWiki(): boolean;
    /**
     *
     */
    set hasWiki(value: boolean);
    /**
     *
     */
    resetHasWiki(): void;
    /**
     *
     */
    get hasWikiInput(): boolean | undefined;
    private _homepageUrl?;
    /**
     *
     */
    get homepageUrl(): string;
    /**
     *
     */
    set homepageUrl(value: string);
    /**
     *
     */
    resetHomepageUrl(): void;
    /**
     *
     */
    get homepageUrlInput(): string | undefined;
    /**
     *
     */
    get htmlUrl(): string;
    /**
     *
     */
    get httpCloneUrl(): string;
    /**
     *
     */
    get id(): string;
    private _isTemplate?;
    /**
     *
     */
    get isTemplate(): boolean;
    /**
     *
     */
    set isTemplate(value: boolean);
    /**
     *
     */
    resetIsTemplate(): void;
    /**
     *
     */
    get isTemplateInput(): boolean | undefined;
    private _licenseTemplate?;
    /**
     *
     */
    get licenseTemplate(): string;
    /**
     *
     */
    set licenseTemplate(value: string);
    /**
     *
     */
    resetLicenseTemplate(): void;
    /**
     *
     */
    get licenseTemplateInput(): string | undefined;
    private _name;
    /**
     *
     */
    get name(): string;
    /**
     *
     */
    set name(value: string);
    /**
     *
     */
    get nameInput(): string;
    /**
     *
     */
    get nodeId(): string;
    private _private?;
    /**
     *
     */
    get private(): boolean;
    /**
     *
     */
    set private(value: boolean);
    /**
     *
     */
    resetPrivate(): void;
    /**
     *
     */
    get privateInput(): boolean | undefined;
    /**
     *
     */
    get sshCloneUrl(): string;
    /**
     *
     */
    get svnUrl(): string;
    private _topics?;
    /**
     *
     */
    get topics(): string[];
    /**
     *
     */
    set topics(value: string[]);
    /**
     *
     */
    resetTopics(): void;
    /**
     *
     */
    get topicsInput(): string[] | undefined;
    private _template?;
    /**
     *
     */
    get template(): RepositoryTemplate[];
    /**
     *
     */
    set template(value: RepositoryTemplate[]);
    /**
     *
     */
    resetTemplate(): void;
    /**
     *
     */
    get templateInput(): RepositoryTemplate[] | undefined;
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
